----------------------------------------------------------------------------------------------
--- Elder Scrolls Online Addon - Mute NPC Dialogue v1.5                                    ---
--- Web Site: http://www.esoui.com/downloads/info422-MuteNPCDialogue.html                  ---
--- MuteDialogueGlobals.lua																   ---
--- Programmed by: @Magicka_Missile  cppdev486+ESOaddon@gmail.com                          ---
--- Description: Gives players the option to mute/unmute individual NPC dialogues in game  ---
--- Notes: This is my first LUA script and my first game addon/mod, so a lot of the code   ---
---        is probably pretty bad. I'd love feedback, suggestions and comments!            ---
--- Thanks: Thanks to awesomebilly for 'Sample Application' at ESOUI to help us newbies    ---
---			to learn ESO Addons. Thanks to Seerah for LibAddonMenu also at ESOUI.          ---
----------------------------------------------------------------------------------------------

--local variables
local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
if ( not LAM ) then 
	d("Error loading LAM")
	return 
end   -- LibAddon Library

local diaString
local npcvol 
local volLoadLevel
local control = ZO_OptionsWindow.controlTable[2][9]
local maxElements = 5000


--Bubble sort type function only with nils O_o
local function BubbleSort()

	local i
	local j
	local flag
	local temp
	local count = 5000
	
	repeat
		flag = 0
		count = count -1
		for j=0, count do
			if muteDialogueSavedVars.muted[j]== nil and muteDialogueSavedVars.muted[j+1] ~= nill then
				muteDialogueSavedVars.muted[j] = muteDialogueSavedVars.muted[j+1]
				muteDialogueSavedVars.muted[j+1] = nil
				flag = 1
			end
		end
	until flag == 0
end

--add a dialogue to our mute list
local function AddDialogue()
    if diaString == nil then
		d("ERROR in MuteDialogue addon: no chatter data to mute!")
		return
	end
	
	--turn down the volume immediately
	SetSetting(control.system, control.settingId, muteDialogueSavedVars.muteLevel) 
	if muteDialogueSavedVars.debug == true then
		d("Immediate mute, volume changed to: ".. muteDialogueSavedVars.muteLevel)
	end
	
	new = 1

	--check to see if the dialogue exists in our array of muted dialogues
	if muteDialogueSavedVars.muted[0] ~= nil then
		for i = 0, 5000 do
			if muteDialogueSavedVars.muted[i] == string.sub (diaString, 1, 25) then
				new = 0
				break
			end
		end
	end


	--if the dialogue is new then add it to the next available array
	if new == 1 then
		if muteDialogueSavedVars.muted[0] == nil then
			muteDialogueSavedVars.muted[0] = string.sub (diaString, 1, 25)
			
			--debug
			if muteDialogueSavedVars.debug == true then
				d("I added: '" .. string.sub (diaString, 1, 25) .. "' at element: 0")
			end
			return
		end
		for i = 0, 5000 do
			if muteDialogueSavedVars.muted[i] == nil then
				if i > maxElements then
					d("ERROR in MuteDialogue addon: max array elements reached. Try unmuting some old dialogues or resetting in options  to make room.")
					return
				end
				
				muteDialogueSavedVars.muted[i] = string.sub (diaString, 1, 25)
				
				--debug
				if muteDialogueSavedVars.debug == true then
					d("I added: '" .. string.sub (diaString, 1, 25) .. "' at element: " .. i)
				end
				break
			end
		end
	end

	ApplySettings() 
	RefreshSettings() 
end

--remove a dialogue from our mute list if it exists
local function RemoveDialogue()
    if diaString == nil then
		d("ERROR in MuteDialogue addon: no chatter data to unmute!")
		return
	end
	
	--turn volume back up immediately
	if muteDialogueSavedVars.stuckVol == true then --error fix
		if (muteDialogueSavedVars.debug == true) then
			d("Vol fix is ON. Turning volume back immediately up to: ".. muteDialogueSavedVars.stuckVolLevel)
		end
		SetSetting(control.system, control.settingId, muteDialogueSavedVars.stuckVolLevel) 
	else
		if muteDialogueSavedVars.debug == true then
			d("Turning the volume back immediately up to: " .. npcvol)
		end
		SetSetting(control.system, control.settingId, npcvol) 
	end
	
	
	if muteDialogueSavedVars.muted[0] == nil then return end
	exists = 0

	--check to see if the dialogue exists in our array of muted dialogues
	for i = 0, 5000 do
		if muteDialogueSavedVars.muted[i] == string.sub (diaString, 1, 25) then
			exists = 1
			break
		end
	end

	--if the dialogue is new then remove it from the array
	if exists == 1 then
		for i = 0, 5000 do
			if muteDialogueSavedVars.muted[i] == string.sub (diaString, 1, 25) then
				muteDialogueSavedVars.muted[i] = nil
				
				--debug
				if muteDialogueSavedVars.debug == true then
					d("I removed: '" .. string.sub (diaString, 1, 25) .. "' at element: " .. i)
				end
				break
			end
		end
	end
	BubbleSort()
	ApplySettings() 
	RefreshSettings() 
end

--reset our saved mute dialogue list to empty
local function Reset()
	--remove all elements from the muted array
	muteDialogueSavedVars.muted = {},
	ApplySettings() 
	RefreshSettings() 
end

--reset our saved mute dialogue list to empty
local function ToggleUILock(lockVal)

	muteDialogueSavedVars.lockUI = lockVal
	
	--remove all elements from the muted array
	if lockVal == true then
		muteDialogue.win.Main_Control:SetMovable(false)
	else 
		muteDialogue.win.Main_Control:SetMovable(true)
	end
	ApplySettings() 
	RefreshSettings() 
end


--save the position of the UI buttons
local function SavePosition(UIBox)
	

	local xPos = UIBox:GetLeft()
	local yPos = UIBox:GetTop()
	
	--debug
	if muteDialogueSavedVars.debug == true then
			d("The UI box has been moved to: ".. xPos.. ", ".. yPos)
	end

	
	--save the offsets
	muteDialogueSavedVars.offsetX = xPos
	muteDialogueSavedVars.offsetY = yPos
	
	ApplySettings() 
	RefreshSettings() 
end

--options menu built with LibAddonMenu by Seerah http://www.esoui.com/downloads/info7-LibAddonMenu.html
local function OptionsMenu(index)
	local muteDialoguePanel = LAM:CreateControlPanel(muteDialogue.vars.appName.. index.. "ControlPanel", "Mute NPC Dialogue")
	
	if muteDialoguePanel ~= nil then
		LAM:AddHeader(muteDialoguePanel, muteDialogue.vars.appName.. index..  "Header1",  muteDialogue.vars.color.colLegendary.. "Settings")
		  
		LAM:AddSlider(muteDialoguePanel, muteDialogue.vars.appName.. index.. "volSlider", "Mute Volume Level", "Turn the volume down to this level for 'muted' NPC dialogues",
		  1, 100, 1, function() return muteDialogueSavedVars.muteLevel end, function(val) muteDialogueSavedVars.muteLevel = val end) 

		LAM:AddCheckbox(muteDialoguePanel, muteDialogue.vars.appName.. index.. "HideOptions", "Hide Mute/Unmute UI", "This will show options to mute and unmute when an NPC talks. If you don't want to see these, then turn this option off and operate the addon with /slash commands.",
		  function() return muteDialogueSavedVars.hideUIOption end,
		  function(val) muteDialogueSavedVars.hideUIOption = val
		  end)
		  
		LAM:AddCheckbox(muteDialoguePanel, muteDialogue.vars.appName.. index.. "LockWindow", "Lock the UI", "This locks the UI buttons to the last place they were moved.",
		  function() return muteDialogueSavedVars.lockUI end,
		  function(val) ToggleUILock(val)
		  end)
		  
		LAM:AddHeader(muteDialoguePanel, muteDialogue.vars.appName.. index..  "Header2",  "")
		
		
		LAM:AddButton(muteDialoguePanel, muteDialogue.vars.appName.. index.. "Reset", "Reset muted NPC dialogues", "This will clear your saved list of muted NPC dialogues.",
		  function() Reset() end)
		
		LAM:AddHeader(muteDialoguePanel, muteDialogue.vars.appName.. index..  "Header3",  "")
		
		LAM:AddCheckbox(muteDialoguePanel, muteDialogue.vars.appName.. index.. "Debug", "Debugger", "This will show debug messages to your chat window.",
		  function() return muteDialogueSavedVars.debug end,
		  function(val) muteDialogueSavedVars.debug = val
		  end)
		LAM:AddDescription(muteDialoguePanel, muteDialogue.vars.appName.. index..  "stuckVolText", "Due to conflicts with other volume type addons, the Mute NPC Dialogue addon may cause the volume to become 'stuck' at 0 or the mute volume level. Either uninstall conflicting addons or turn the fix on below. Note: This will override your NPC volume setting in the main game settings.")

		
		LAM:AddCheckbox(muteDialoguePanel, muteDialogue.vars.appName.. index.. "StuckVol", "Stuck Volume Fix", "Due to conflicts with other addons, volume may get 'stuck' at 0 or the mute volume level.",
		  function() return muteDialogueSavedVars.stuckVol end,
		  function(val) muteDialogueSavedVars.stuckVol = val
		  end)
		  
		LAM:AddSlider(muteDialoguePanel, muteDialogue.vars.appName.. index.. "stuckVolSlider", "Unmute Volume Level (Optional)", "Turn the volume back up to this level after a mute. Only applies if the 'stuck volume fix' is turned on.",
		  1, 100, 1, function() return muteDialogueSavedVars.stuckVolLevel end, function(val) muteDialogueSavedVars.stuckVolLevel = val end)
		  
		LAM:AddHeader(muteDialoguePanel, muteDialogue.vars.appName.. index..  "Header4",  "")  
		
		LAM:AddDescription(muteDialoguePanel, muteDialogue.vars.appName.. index..  "OptionText", "/mutedialogue to mute once dialogue has been opened. \n/unmutedialogue to unmute.","Slash Commands")
		
		LAM:AddDescription(muteDialoguePanel, muteDialogue.vars.appName.. index..  "AboutText", "Author: @Magicka_Missile\nVersion 1.5",muteDialogue.vars.color.colRed.. "About")
	end
end

--User Interface for adding and removing dialogues to mute list
local function SetupUI()

	--Main Controller.
	muteDialogue.win.Main_Control = muteDialogue.win.wm:CreateTopLevelWindow("muteDialoguelicationMainController")
	if muteDialogueSavedVars.offsetX == 0 and muteDialogueSavedVars.offsetY == 0 then
		muteDialogue.win.Main_Control:SetAnchor(CENTER,GuiRoot,CENTER,-200,-150)
	else
		muteDialogue.win.Main_Control:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT,muteDialogueSavedVars.offsetX,muteDialogueSavedVars.offsetY)
	end
	muteDialogue.win.Main_Control:SetMovable(true)
	muteDialogue.win.Main_Control:SetMouseEnabled(true)
	muteDialogue.win.Main_Control:SetDimensions(200,100)
	muteDialogue.win.Main_Control:SetHidden(true)
	muteDialogue.win.Main_Control:SetAlpha(1)
	muteDialogue.win.Main_Control:SetClampedToScreen(true)
	muteDialogue.win.Main_Control:SetHandler("OnMoveStop", function(self) SavePosition(self) end)  -- this is the method to call once the mouse is unclicked


	--These are the two buttons to add and remove NPC dialogues to mute list
	muteDialogue.win.Main_Control.AddBtn = CreateControlFromVirtual("addBtn", muteDialogue.win.Main_Control, "ZO_DefaultButton")
	muteDialogue.win.Main_Control.AddBtn:SetAnchor(CENTER, muteDialogue.win.Main_Control, CENTER, 0, -25)
	muteDialogue.win.Main_Control.AddBtn:SetWidth(150)
	muteDialogue.win.Main_Control.AddBtn:SetText("Mute Dialogue") -- Using localization here.
	muteDialogue.win.Main_Control.AddBtn:SetHandler("OnClicked", function() AddDialogue() end)  -- this is the method to call once clicked

	muteDialogue.win.Main_Control.RemoveBtn = CreateControlFromVirtual("RemoveBtn", muteDialogue.win.Main_Control, "ZO_DefaultButton")
	muteDialogue.win.Main_Control.RemoveBtn:SetAnchor(TOPLEFT, muteDialogue.win.Main_Control.AddBtn, BOTTOMLEFT, 0, 0)
	muteDialogue.win.Main_Control.RemoveBtn:SetWidth(150)
	muteDialogue.win.Main_Control.RemoveBtn:SetText("Unmute Dialogue") -- Using localization here.
	muteDialogue.win.Main_Control.RemoveBtn:SetHandler("OnClicked", function() RemoveDialogue() end)  -- this is the method to call once clicked


end

--Show the UI
local function ShowUI()
	if muteDialogueSavedVars.hideUIOption == false then
		muteDialogue.win.Main_Control:SetHidden(false)
	end
end

--Hide the UI
local function HideUI()
  muteDialogue.win.Main_Control:SetHidden(true)
end

--player starts a dialogue with an NPC
local function NPCDialogStart(eventCode)
	--set initial NPC volume
	npcvol = GetSetting(control.system, control.settingId)
	
	local exists = 0
	
	--show the UI
	ShowUI()
	
	if muteDialogueSavedVars.debug == true then
		d("The dialog with the NPC just started and the volume is: ".. npcvol)
	end
	
	--get the dialogue text
	z,y,z = GetChatterData() 
	diaString = z

	--check to see if the dialogue exists in our array of muted dialogues
	if muteDialogueSavedVars.muted[0] ~= nil then
		for i = 0, 5000 do
			if muteDialogueSavedVars.muted[i] == string.sub (diaString, 1, 25) then
				exists = 1
				break
			end
		end
	end

	--turn the volume down
	if exists == 1 then
		SetSetting(control.system, control.settingId, muteDialogueSavedVars.muteLevel) 
		if muteDialogueSavedVars.debug == true then
			d("Dialogue found, volume changed to: ".. muteDialogueSavedVars.muteLevel)
		end
	end
	
end

--player ends a dialogue with an NPC
local function NPCDialogEnd()
	if muteDialogueSavedVars.debug == true then
		d("The dialog with the NPC just ended and the volume is: ".. tostring(npcvol))
	end
	
	--remove the UI
	HideUI()
	
	--turn volume back up
	tmp = tonumber(npcvol)
	if muteDialogueSavedVars.stuckVol == true then --error fix
		if (muteDialogueSavedVars.debug == true) then
			d("Vol fix is ON. Turning volume back up to: ".. muteDialogueSavedVars.stuckVolLevel)
		end
		SetSetting(control.system, control.settingId, muteDialogueSavedVars.stuckVolLevel) 
	else
		if muteDialogueSavedVars.debug == true then
			d("Turning the volume back up to: " .. npcvol)
		end                                 
		SetSetting(control.system, control.settingId, npcvol) 
	end
	

end

--
--local function NPCDialogMoved()
--	if muteDialogueSavedVars.debug == true then
--		tmp = GetSetting(control.system, control.settingId)
--		d("New movement in UI mode, vol is: ".. tmp)
--	end
--	
--	--remove the UI
--	HideUI()
--	
--	--turn volume back up
--	SetSetting(control.system, control.settingId, npcvol) 
--	
--	if muteDialogueSavedVars.debug == true then
--		tmp = GetSetting(control.system, control.settingId)
--		d("Turning the volume back up to: ".. npcvol)
--	end
--end

--function first run when addon is loaded
local function OnAddOnLoaded( eventCode, addOnName )
	if ( addOnName ~= muteDialogue.vars.appName ) then return end   
	
		--set defaults
	local defaults = {
					["offsetX"] = 0,
					["offsetY"] = 0,
					["lockUI"] = false,
					["hideUIOption"] = false,
					["stuckVol"] = false,
					["muteLevel"] = 1,
					["stuckVolLevel"] = 75,
					["debug"] = false,
					["muted"] = {},
	}
	muteDialogueSavedVars = ZO_SavedVars:New("MuteDialogue_Settings", 1, nil, defaults, nil)
	
	--debug
	if muteDialogueSavedVars.debug == true then
		d("The muteDialog addon was loaded with debug mode ON")
	end


	--set event handlers
	EVENT_MANAGER:RegisterForEvent(muteDialogue.vars.appName,  EVENT_CHATTER_BEGIN , NPCDialogStart)
	--EVENT_MANAGER:RegisterForEvent(muteDialogue.vars.appName,  EVENT_NEW_MOVEMENT_IN_UI_MODE, NPCDialogMoved)
	EVENT_MANAGER:RegisterForEvent(muteDialogue.vars.appName,  EVENT_CHATTER_END , NPCDialogEnd)

	--set up the option menu
	OptionsMenu(1)
	
	--set up the UI
	SetupUI()
		
	
	
	
end  


--Register load event
EVENT_MANAGER:RegisterForEvent(muteDialogue.vars.appName, EVENT_ADD_ON_LOADED, OnAddOnLoaded)


--Slash commands for mute/unmute
SLASH_COMMANDS["/mutedialogue"]= AddDialogue
SLASH_COMMANDS["/unmutedialogue"]= RemoveDialogue
